Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.joone.engine.extenders
Class BatchModeExtender

    java.lang.Object
      org.joone.engine.extenders.LearnerExtender
          org.joone.engine.extenders.UpdateWeightExtender
              org.joone.engine.extenders.BatchModeExtender

    public class BatchModeExtender

extends UpdateWeightExtender

This class implements the offline learning, that is, batch mode. Weights are updated after Monitor.getBatchSize() cycles.

Author:
  Boris Jansen

Constructor Summary
`BatchModeExtender()` Creates a new instance of BatchModeExtender

Method Summary
`int` | `getBatchSize()` Deprecated. use monitor.getBatchSize()
`protected void` | `initiateNewBatch()` Initiates a new batch (at the beginning or when the dimensions change).
`void` | `postBiasUpdate(double[] currentGradientOuts)` Gives extenders a change to do some post-computing after the biases are updated.
`void` | `postWeightUpdate(double[] currentPattern, double[] currentInps)` Gives extenders a change to do some post-computing after the weights are updated.
`void` | `preBiasUpdate(double[] currentGradientOuts)` Gives extenders a change to do some pre-computing before the biases are updated.
`void` | `preWeightUpdate(double[] currentPattern, double[] currentInps)` Gives extenders a change to do some pre-computing before the weights are updated.
`protected void` | `resetDelta(Matrix aMatrix)` Resets delta values to zero.
`void` | `setBatchSize(int aBatchSize)` Deprecated. use monitor.setBatchSize()
`boolean` | `storeWeightsBiases()` Checks if the weights or biases will be stored this cycle.
`void` | `updateBias(int i, double aDelta)` Updates a bias with the calculated delta value.
`void` | `updateWeight(int j, int k, double aDelta)` Updates a weight with the calculated delta value.

Methods inherited from class org.joone.engine.extenders.LearnerExtender
`getLearner, isEnabled, setEnabled, setLearner`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### BatchModeExtender

    public BatchModeExtender()

  Creates a new instance of BatchModeExtender

Method Detail

### postBiasUpdate

    public void postBiasUpdate(double[] currentGradientOuts)

  Description copied from class: `LearnerExtender`
  Gives extenders a change to do some post-computing after the biases are updated.

  Specified by:
    `postBiasUpdate` in class `LearnerExtender`
  Parameters:
    `currentGradientOuts` - the back propagated gradients.

### postWeightUpdate

    public void postWeightUpdate(double[] currentPattern,
                                 double[] currentInps)

  Description copied from class: `LearnerExtender`
  Gives extenders a change to do some post-computing after the weights are updated.

  Specified by:
    `postWeightUpdate` in class `LearnerExtender`
  Parameters:
    `currentPattern` - the back propagated gradients.
    `currentInps` - the forwarded input.

### preBiasUpdate

    public void preBiasUpdate(double[] currentGradientOuts)

  Description copied from class: `LearnerExtender`
  Gives extenders a change to do some pre-computing before the biases are updated.

  Specified by:
    `preBiasUpdate` in class `LearnerExtender`
  Parameters:
    `currentGradientOuts` - the back propagated gradients.

### preWeightUpdate

    public void preWeightUpdate(double[] currentPattern,
                                double[] currentInps)

  Description copied from class: `LearnerExtender`
  Gives extenders a change to do some pre-computing before the weights are updated.

  Specified by:
    `preWeightUpdate` in class `LearnerExtender`
  Parameters:
    `currentPattern` - the back propagated gradients.
    `currentInps` - the forwarded input.

### updateBias

    public void updateBias(int i,
                           double aDelta)

  Description copied from class: `UpdateWeightExtender`
  Updates a bias with the calculated delta value.

  Specified by:
    `updateBias` in class `UpdateWeightExtender`
  Parameters:
    `i` - the index of the bias to update.
    `aDelta` - the calculated delta value.

### updateWeight

    public void updateWeight(int j,
                             int k,
                             double aDelta)

  Description copied from class: `UpdateWeightExtender`
  Updates a weight with the calculated delta value.

  Specified by:
    `updateWeight` in class `UpdateWeightExtender`
  Parameters:
    `j` - the input index of the weight to update.
    `k` - the output index of the weight to update.
    `aDelta` - the calculated delta value.

### resetDelta

    protected void resetDelta(Matrix aMatrix)

  Resets delta values to zero.

  Parameters:
    `aMatrix` - the matrix for which we need to set the delta values to zero.

### initiateNewBatch

    protected void initiateNewBatch()

  Initiates a new batch (at the beginning or when the dimensions change).

### setBatchSize

    public void setBatchSize(int aBatchSize)

  Deprecated. use monitor.setBatchSize()

  Sets the batchsize. Used for backward compatibility. Use monitor.setBatchSize() instead.

  Parameters:
    `aBatchSize` - the new batchsize.

### getBatchSize

    public int getBatchSize()

  Deprecated. use monitor.getBatchSize()

  Gets the batchsize. Used for backward compatibility. Use monitor.getBatchSize() instead.

  Returns:
    the batch size.

### storeWeightsBiases

    public boolean storeWeightsBiases()

  Description copied from class: `UpdateWeightExtender`
  Checks if the weights or biases will be stored this cycle.

  Specified by:
    `storeWeightsBiases` in class `UpdateWeightExtender`
  Returns:
    true if the weights or biases will be stored this cycle, false otherwise.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit Feedback to pmarrone@users.sourceforge.net